#include <LiquidCrystal_I2C.h>
#include <Wire.h>

#define PIN_A 4
#define PIN_B 5

LiquidCrystal_I2C lcd(0x27,20,4);

float diff;
float vel;
unsigned long timeFirst;
unsigned long timeScnd;
float speedConst = 447.3;

byte customChar0[8] = {
  B01000,
  B01100,
  B01110,
  B01111,
  B01110,
  B01100,
  B01000,
  B00000
};

void configLCD(){
  lcd.createChar(0, customChar0);
  lcd.setCursor(0,0);
  lcd.write(0);
  lcd.write(0);
  lcd.write(0);
  lcd.write(0);
  lcd.write(0);
  lcd.setCursor(5,0);
  lcd.print("SPEED TEST");
  lcd.setCursor(15,0);
  lcd.write(0);
  lcd.write(0);
  lcd.write(0);
  lcd.write(0);
  lcd.write(0);
  lcd.setCursor(0,1);
  lcd.print("P1:");
  lcd.setCursor(0,2);
  lcd.print("P2:");
  lcd.setCursor(0,3);
  lcd.print("Speed:");
}

void setup() {
  pinMode(PIN_A, INPUT);
  pinMode(PIN_B, INPUT);
  lcd.begin();
  lcd.backlight();
  configLCD();
}

void loop() {
    // Asteptam semnal de la primul LED
    while (digitalRead(PIN_A) != LOW) ;
    timeFirst = millis();
    digitalWrite(PIN_LED, LOW);
    // Asteptam semnal de la al doilea LED
    while (digitalRead(PIN_B) != LOW) ;
    timeScnd = millis();
    // Calculam viteza si afisam rezultatul
    lcd.setCursor(6, 1);
    lcd.print(timeFirst);
    diff = timeScnd - timeFirst; 
    vel = speedConst / diff;
    lcd.setCursor(6, 2);
    lcd.print(timeScnd); 
    lcd.setCursor(6,3);
    lcd.print(vel);
    lcd.print("km/h");
    delay(5000);     
    lcd.clear();
    configLCD(); 
}
